/**
 * 
 */
package org.richfaces.taglib;

import javax.el.MethodExpression;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;

import com.sun.facelets.FaceletContext;
import com.sun.facelets.tag.MetaRule;
import com.sun.facelets.tag.MetaRuleset;
import com.sun.facelets.tag.Metadata;
import com.sun.facelets.tag.MetadataTarget;
import com.sun.facelets.tag.TagAttribute;
import com.sun.facelets.tag.jsf.ComponentConfig;
import com.sun.facelets.tag.jsf.ComponentHandler;

/**
 * @author Konstantin Mishin
 *
 */
public class ColumnTagHandler extends ComponentHandler {

	private final static String FILTER_METHOD = "filterMethod";

	public ColumnTagHandler(ComponentConfig config) {
		super(config);
	}
	
	@SuppressWarnings("unchecked")
	@Override
	protected MetaRuleset createMetaRuleset(Class type) {
		MetaRuleset ruleset = super.createMetaRuleset(type);
		
		ruleset.addRule(new MetaRule() {

			@Override
			public Metadata applyRule(String name, final TagAttribute attribute, MetadataTarget metadataTarget) {
				if (FILTER_METHOD.equals(name)) {
					return new Metadata() {
						public void applyMetadata(FaceletContext context, Object object) {
							FacesContext facesContext = context.getFacesContext();
							
							MethodExpression expression = facesContext.getApplication().getExpressionFactory().
								createMethodExpression(facesContext.getELContext(), attribute.getValue(), boolean.class, new Class[]{Object.class});
							((UIComponent) object).getAttributes().put(FILTER_METHOD, expression);
						}
					};
				}
				
				return null;
			}
		});
		
		return ruleset;
	}
}
